Index: uspace/app/uidemo/uidemo.c
===================================================================
--- uspace/app/uidemo/uidemo.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/uidemo/uidemo.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -44,11 +44,16 @@
 #include <ui/image.h>
 #include <ui/label.h>
+#include <ui/list.h>
+#include <ui/menu.h>
 #include <ui/menubar.h>
+#include <ui/menudd.h>
 #include <ui/menuentry.h>
-#include <ui/menu.h>
 #include <ui/msgdialog.h>
 #include <ui/pbutton.h>
 #include <ui/promptdialog.h>
 #include <ui/resource.h>
+#include <ui/selectdialog.h>
+#include <ui/tab.h>
+#include <ui/tabset.h>
 #include <ui/ui.h>
 #include <ui/window.h>
@@ -85,4 +90,18 @@
 static ui_slider_cb_t slider_cb = {
 	.moved = slider_moved
+};
+
+static void scrollbar_up(ui_scrollbar_t *, void *);
+static void scrollbar_down(ui_scrollbar_t *, void *);
+static void scrollbar_page_up(ui_scrollbar_t *, void *);
+static void scrollbar_page_down(ui_scrollbar_t *, void *);
+static void scrollbar_moved(ui_scrollbar_t *, void *, gfx_coord_t);
+
+static ui_scrollbar_cb_t scrollbar_cb = {
+	.up = scrollbar_up,
+	.down = scrollbar_down,
+	.page_up = scrollbar_page_up,
+	.page_down = scrollbar_page_down,
+	.moved = scrollbar_moved
 };
 
@@ -91,4 +110,5 @@
 static void uidemo_file_exit(ui_menu_entry_t *, void *);
 static void uidemo_edit_modify(ui_menu_entry_t *, void *);
+static void uidemo_edit_insert_character(ui_menu_entry_t *, void *);
 
 static void file_dialog_bok(ui_file_dialog_t *, void *, const char *);
@@ -110,4 +130,14 @@
 	.bcancel = prompt_dialog_bcancel,
 	.close = prompt_dialog_close
+};
+
+static void select_dialog_bok(ui_select_dialog_t *, void *, void *);
+static void select_dialog_bcancel(ui_select_dialog_t *, void *);
+static void select_dialog_close(ui_select_dialog_t *, void *);
+
+static ui_select_dialog_cb_t select_dialog_cb = {
+	.bok = select_dialog_bok,
+	.bcancel = select_dialog_bcancel,
+	.close = select_dialog_close
 };
 
@@ -215,4 +245,99 @@
 }
 
+/** Scrollbar up button pressed.
+ *
+ * @param scrollbar Scrollbar
+ * @param arg Argument (demo)
+ */
+static void scrollbar_up(ui_scrollbar_t *scrollbar, void *arg)
+{
+	gfx_coord_t pos;
+
+	pos = ui_scrollbar_get_pos(scrollbar);
+	ui_scrollbar_set_pos(scrollbar, pos - 1);
+
+	pos = ui_scrollbar_get_pos(scrollbar);
+	scrollbar_moved(scrollbar, arg, pos);
+}
+
+/** Scrollbar down button pressed.
+ *
+ * @param scrollbar Scrollbar
+ * @param arg Argument (demo)
+ */
+static void scrollbar_down(ui_scrollbar_t *scrollbar, void *arg)
+{
+	gfx_coord_t pos;
+
+	pos = ui_scrollbar_get_pos(scrollbar);
+	ui_scrollbar_set_pos(scrollbar, pos + 1);
+
+	pos = ui_scrollbar_get_pos(scrollbar);
+	scrollbar_moved(scrollbar, arg, pos);
+}
+
+/** Scrollbar page up event.
+ *
+ * @param scrollbar Scrollbar
+ * @param arg Argument (demo)
+ */
+static void scrollbar_page_up(ui_scrollbar_t *scrollbar, void *arg)
+{
+	gfx_coord_t pos;
+
+	pos = ui_scrollbar_get_pos(scrollbar);
+	ui_scrollbar_set_pos(scrollbar, pos -
+	    ui_scrollbar_trough_length(scrollbar) / 4);
+
+	pos = ui_scrollbar_get_pos(scrollbar);
+	scrollbar_moved(scrollbar, arg, pos);
+}
+
+/** Scrollbar page down event.
+ *
+ * @param scrollbar Scrollbar
+ * @param arg Argument (demo)
+ */
+static void scrollbar_page_down(ui_scrollbar_t *scrollbar, void *arg)
+{
+	gfx_coord_t pos;
+
+	pos = ui_scrollbar_get_pos(scrollbar);
+	ui_scrollbar_set_pos(scrollbar, pos +
+	    ui_scrollbar_trough_length(scrollbar) / 4);
+
+	pos = ui_scrollbar_get_pos(scrollbar);
+	scrollbar_moved(scrollbar, arg, pos);
+}
+
+/** Scrollbar was moved.
+ *
+ * @param scrollbar Scrollbar
+ * @param arg Argument (demo)
+ * @param pos Position
+ */
+static void scrollbar_moved(ui_scrollbar_t *scrollbar, void *arg,
+    gfx_coord_t pos)
+{
+	ui_demo_t *demo = (ui_demo_t *) arg;
+	char *str;
+	errno_t rc;
+	int rv;
+
+	rv = asprintf(&str, "Scrollbar: %d of %d", (int) pos,
+	    ui_scrollbar_move_length(scrollbar));
+	if (rv < 0) {
+		printf("Out of memory.\n");
+		return;
+	}
+
+	rc = ui_entry_set_text(demo->entry, str);
+	if (rc != EOK)
+		printf("Error changing entry text.\n");
+	(void) ui_entry_paint(demo->entry);
+
+	free(str);
+}
+
 /** Display a message window.
  *
@@ -320,9 +445,64 @@
 	rc = ui_prompt_dialog_create(demo->ui, &pdparams, &dialog);
 	if (rc != EOK) {
-		printf("Error creating message dialog.\n");
+		printf("Error creating prompt dialog.\n");
 		return;
 	}
 
 	ui_prompt_dialog_set_cb(dialog, &prompt_dialog_cb, demo);
+}
+
+/** Edit / Insert Character menu entry selected.
+ *
+ * @param mentry Menu entry
+ * @param arg Argument (demo)
+ */
+static void uidemo_edit_insert_character(ui_menu_entry_t *mentry, void *arg)
+{
+	ui_demo_t *demo = (ui_demo_t *) arg;
+	ui_select_dialog_params_t sdparams;
+	ui_select_dialog_t *dialog;
+	ui_list_entry_attr_t attr;
+	errno_t rc;
+
+	ui_select_dialog_params_init(&sdparams);
+	sdparams.caption = "Insert Character";
+	sdparams.prompt = "Select character to insert";
+
+	rc = ui_select_dialog_create(demo->ui, &sdparams, &dialog);
+	if (rc != EOK) {
+		printf("Error creating select dialog.\n");
+		return;
+	}
+
+	ui_list_entry_attr_init(&attr);
+	attr.caption = "Dollar sign ($)";
+	attr.arg = (void *)'$';
+	rc = ui_select_dialog_append(dialog, &attr);
+	if (rc != EOK) {
+		printf("Error appending entry to list.\n");
+		return;
+	}
+
+	ui_list_entry_attr_init(&attr);
+	attr.caption = "Hash sign (#)";
+	attr.arg = (void *)'#';
+	rc = ui_select_dialog_append(dialog, &attr);
+	if (rc != EOK) {
+		printf("Error appending entry to list.\n");
+		return;
+	}
+
+	ui_list_entry_attr_init(&attr);
+	attr.caption = "Question mark (?)";
+	attr.arg = (void *)'?';
+	rc = ui_select_dialog_append(dialog, &attr);
+	if (rc != EOK) {
+		printf("Error appending entry to list.\n");
+		return;
+	}
+
+	ui_select_dialog_set_cb(dialog, &select_dialog_cb, demo);
+
+	(void) ui_select_dialog_paint(dialog);
 }
 
@@ -413,5 +593,5 @@
 /** Prompt dialog cancel button press.
  *
- * @param dialog File dialog
+ * @param dialog Prompt dialog
  * @param arg Argument (ui_demo_t *)
  */
@@ -426,5 +606,5 @@
 /** Prompt dialog close request.
  *
- * @param dialog File dialog
+ * @param dialog Prompt dialog
  * @param arg Argument (ui_demo_t *)
  */
@@ -435,4 +615,48 @@
 	(void) demo;
 	ui_prompt_dialog_destroy(dialog);
+}
+
+/** Select dialog OK button press.
+ *
+ * @param dialog Select dialog
+ * @param arg Argument (ui_demo_t *)
+ * @param text Submitted text
+ */
+static void select_dialog_bok(ui_select_dialog_t *dialog, void *arg,
+    void *earg)
+{
+	ui_demo_t *demo = (ui_demo_t *) arg;
+	char str[2];
+
+	ui_select_dialog_destroy(dialog);
+	str[0] = (char)(intptr_t)earg;
+	str[1] = '\0';
+	(void) ui_entry_insert_str(demo->entry, str);
+}
+
+/** Select dialog cancel button press.
+ *
+ * @param dialog Select dialog
+ * @param arg Argument (ui_demo_t *)
+ */
+static void select_dialog_bcancel(ui_select_dialog_t *dialog, void *arg)
+{
+	ui_demo_t *demo = (ui_demo_t *) arg;
+
+	(void) demo;
+	ui_select_dialog_destroy(dialog);
+}
+
+/** Select dialog close request.
+ *
+ * @param dialog Select dialog
+ * @param arg Argument (ui_demo_t *)
+ */
+static void select_dialog_close(ui_select_dialog_t *dialog, void *arg)
+{
+	ui_demo_t *demo = (ui_demo_t *) arg;
+
+	(void) demo;
+	ui_select_dialog_destroy(dialog);
 }
 
@@ -486,5 +710,7 @@
 	ui_menu_entry_t *mexit;
 	ui_menu_entry_t *mmodify;
+	ui_menu_entry_t *minsert_char;
 	ui_menu_entry_t *mabout;
+	ui_list_entry_attr_t eattr;
 	errno_t rc;
 
@@ -500,5 +726,5 @@
 	ui_wnd_params_init(&params);
 	params.caption = "UI Demo";
-	params.style |= ui_wds_resizable;
+	params.style |= ui_wds_maximize_btn | ui_wds_resizable;
 
 	/* FIXME: Auto layout */
@@ -506,11 +732,11 @@
 		params.rect.p0.x = 0;
 		params.rect.p0.y = 0;
-		params.rect.p1.x = 44;
-		params.rect.p1.y = 21;
+		params.rect.p1.x = 46;
+		params.rect.p1.y = 25;
 	} else {
 		params.rect.p0.x = 0;
 		params.rect.p0.y = 0;
-		params.rect.p1.x = 220;
-		params.rect.p1.y = 350;
+		params.rect.p1.x = 255;
+		params.rect.p1.y = 410;
 	}
 
@@ -539,5 +765,5 @@
 	}
 
-	rc = ui_menu_create(demo.mbar, "File", &demo.mfile);
+	rc = ui_menu_dd_create(demo.mbar, "~F~ile", NULL, &demo.mfile);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -545,5 +771,5 @@
 	}
 
-	rc = ui_menu_entry_create(demo.mfile, "Message", "", &mmsg);
+	rc = ui_menu_entry_create(demo.mfile, "~M~essage", "", &mmsg);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -553,5 +779,5 @@
 	ui_menu_entry_set_cb(mmsg, uidemo_file_message, (void *) &demo);
 
-	rc = ui_menu_entry_create(demo.mfile, "Load", "", &mload);
+	rc = ui_menu_entry_create(demo.mfile, "~L~oad", "", &mload);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -561,5 +787,5 @@
 	ui_menu_entry_set_cb(mload, uidemo_file_load, (void *) &demo);
 
-	rc = ui_menu_entry_create(demo.mfile, "Foo", "Ctrl-Alt-Del", &mfoo);
+	rc = ui_menu_entry_create(demo.mfile, "~F~oo", "Ctrl-Alt-Del", &mfoo);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -567,5 +793,5 @@
 	}
 
-	rc = ui_menu_entry_create(demo.mfile, "Bar", "", &mbar);
+	rc = ui_menu_entry_create(demo.mfile, "~B~ar", "", &mbar);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -573,5 +799,5 @@
 	}
 
-	rc = ui_menu_entry_create(demo.mfile, "Foobar", "", &mfoobar);
+	rc = ui_menu_entry_create(demo.mfile, "F~o~obar", "", &mfoobar);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -579,4 +805,6 @@
 	}
 
+	ui_menu_entry_set_disabled(mfoobar, true);
+
 	rc = ui_menu_entry_sep_create(demo.mfile, &msep);
 	if (rc != EOK) {
@@ -585,5 +813,5 @@
 	}
 
-	rc = ui_menu_entry_create(demo.mfile, "Exit", "Alt-F4", &mexit);
+	rc = ui_menu_entry_create(demo.mfile, "E~x~it", "Alt-F4", &mexit);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -593,5 +821,5 @@
 	ui_menu_entry_set_cb(mexit, uidemo_file_exit, (void *) &demo);
 
-	rc = ui_menu_create(demo.mbar, "Edit", &demo.medit);
+	rc = ui_menu_dd_create(demo.mbar, "~E~dit", NULL, &demo.medit);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -599,5 +827,5 @@
 	}
 
-	rc = ui_menu_entry_create(demo.medit, "Modify", "", &mmodify);
+	rc = ui_menu_entry_create(demo.medit, "~M~odify", "", &mmodify);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -607,5 +835,6 @@
 	ui_menu_entry_set_cb(mmodify, uidemo_edit_modify, (void *) &demo);
 
-	rc = ui_menu_create(demo.mbar, "Preferences", &demo.mpreferences);
+	rc = ui_menu_entry_create(demo.medit, "~I~nsert Character",
+	    "", &minsert_char);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -613,5 +842,9 @@
 	}
 
-	rc = ui_menu_create(demo.mbar, "Help", &demo.mhelp);
+	ui_menu_entry_set_cb(minsert_char, uidemo_edit_insert_character,
+	    (void *) &demo);
+
+	rc = ui_menu_dd_create(demo.mbar, "~P~references", NULL,
+	    &demo.mpreferences);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -619,5 +852,11 @@
 	}
 
-	rc = ui_menu_entry_create(demo.mhelp, "About", "Ctrl-H, F1", &mabout);
+	rc = ui_menu_dd_create(demo.mbar, "~H~elp", NULL, &demo.mhelp);
+	if (rc != EOK) {
+		printf("Error creating menu.\n");
+		return rc;
+	}
+
+	rc = ui_menu_entry_create(demo.mhelp, "~A~bout", "Ctrl-H, F1", &mabout);
 	if (rc != EOK) {
 		printf("Error creating menu.\n");
@@ -634,7 +873,8 @@
 		rect.p0.x = 4;
 		rect.p0.y = 30;
-		rect.p1.x = 216;
+		rect.p1.x = 251;
 		rect.p1.y = 52;
 	}
+
 	ui_menu_bar_set_rect(demo.mbar, &rect);
 
@@ -645,4 +885,49 @@
 	}
 
+	rc = ui_tab_set_create(ui_res, &demo.tabset);
+	if (rc != EOK) {
+		printf("Error creating tab set.\n");
+		return rc;
+	}
+
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 2;
+		rect.p0.y = 2;
+		rect.p1.x = 44;
+		rect.p1.y = 24;
+	} else {
+		rect.p0.x = 8;
+		rect.p0.y = 53;
+		rect.p1.x = 250;
+		rect.p1.y = 405;
+	}
+
+	ui_tab_set_set_rect(demo.tabset, &rect);
+
+	rc = ui_tab_create(demo.tabset, "Basic", &demo.tbasic);
+	if (rc != EOK) {
+		printf("Error creating tab.\n");
+		return rc;
+	}
+
+	rc = ui_tab_create(demo.tabset, "Lists", &demo.tlists);
+	if (rc != EOK) {
+		printf("Error creating tab.\n");
+		return rc;
+	}
+
+	rc = ui_fixed_add(demo.fixed, ui_tab_set_ctl(demo.tabset));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
+	rc = ui_fixed_create(&demo.bfixed);
+	if (rc != EOK) {
+		printf("Error creating fixed layout.\n");
+		return rc;
+	}
+
 	rc = ui_entry_create(window, "", &demo.entry);
 	if (rc != EOK) {
@@ -653,13 +938,13 @@
 	/* FIXME: Auto layout */
 	if (ui_is_textmode(ui)) {
-		rect.p0.x = 2;
-		rect.p0.y = 3;
-		rect.p1.x = 42;
-		rect.p1.y = 4;
+		rect.p0.x = 4;
+		rect.p0.y = 5;
+		rect.p1.x = 41;
+		rect.p1.y = 6;
 	} else {
 		rect.p0.x = 15;
-		rect.p0.y = 53;
+		rect.p0.y = 88;
 		rect.p1.x = 205;
-		rect.p1.y = 78;
+		rect.p1.y = 113;
 	}
 
@@ -667,5 +952,5 @@
 	ui_entry_set_halign(demo.entry, gfx_halign_center);
 
-	rc = ui_fixed_add(demo.fixed, ui_entry_ctl(demo.entry));
+	rc = ui_fixed_add(demo.bfixed, ui_entry_ctl(demo.entry));
 	if (rc != EOK) {
 		printf("Error adding control to layout.\n");
@@ -681,13 +966,13 @@
 	/* FIXME: Auto layout */
 	if (ui_is_textmode(ui)) {
-		rect.p0.x = 2;
-		rect.p0.y = 5;
-		rect.p1.x = 42;
-		rect.p1.y = 6;
+		rect.p0.x = 4;
+		rect.p0.y = 7;
+		rect.p1.x = 41;
+		rect.p1.y = 8;
 	} else {
 		rect.p0.x = 60;
-		rect.p0.y = 88;
+		rect.p0.y = 123;
 		rect.p1.x = 160;
-		rect.p1.y = 101;
+		rect.p1.y = 136;
 	}
 
@@ -695,5 +980,5 @@
 	ui_label_set_halign(demo.label, gfx_halign_center);
 
-	rc = ui_fixed_add(demo.fixed, ui_label_ctl(demo.label));
+	rc = ui_fixed_add(demo.bfixed, ui_label_ctl(demo.label));
 	if (rc != EOK) {
 		printf("Error adding control to layout.\n");
@@ -711,13 +996,13 @@
 	/* FIXME: Auto layout */
 	if (ui_is_textmode(ui)) {
-		rect.p0.x = 2;
-		rect.p0.y = 7;
-		rect.p1.x = 12;
-		rect.p1.y = 8;
+		rect.p0.x = 4;
+		rect.p0.y = 9;
+		rect.p1.x = 15;
+		rect.p1.y = 10;
 	} else {
 		rect.p0.x = 15;
-		rect.p0.y = 111;
+		rect.p0.y = 146;
 		rect.p1.x = 105;
-		rect.p1.y = 139;
+		rect.p1.y = 174;
 	}
 
@@ -726,5 +1011,5 @@
 	ui_pbutton_set_default(demo.pb1, true);
 
-	rc = ui_fixed_add(demo.fixed, ui_pbutton_ctl(demo.pb1));
+	rc = ui_fixed_add(demo.bfixed, ui_pbutton_ctl(demo.pb1));
 	if (rc != EOK) {
 		printf("Error adding control to layout.\n");
@@ -741,18 +1026,18 @@
 
 	if (ui_is_textmode(ui)) {
-		rect.p0.x = 32;
-		rect.p0.y = 7;
-		rect.p1.x = 42;
-		rect.p1.y = 8;
+		rect.p0.x = 30;
+		rect.p0.y = 9;
+		rect.p1.x = 41;
+		rect.p1.y = 10;
 	} else {
 		rect.p0.x = 115;
-		rect.p0.y = 111;
+		rect.p0.y = 146;
 		rect.p1.x = 205;
-		rect.p1.y = 139;
+		rect.p1.y = 174;
 	}
 
 	ui_pbutton_set_rect(demo.pb2, &rect);
 
-	rc = ui_fixed_add(demo.fixed, ui_pbutton_ctl(demo.pb2));
+	rc = ui_fixed_add(demo.bfixed, ui_pbutton_ctl(demo.pb2));
 	if (rc != EOK) {
 		printf("Error adding control to layout.\n");
@@ -764,5 +1049,5 @@
 		bparams.rect.p0.x = 0;
 		bparams.rect.p0.y = 0;
-		bparams.rect.p1.x = 40;
+		bparams.rect.p1.x = 37;
 		bparams.rect.p1.y = 2;
 	} else {
@@ -788,9 +1073,9 @@
 
 	if (ui_is_textmode(ui)) {
-		off.x = 2;
-		off.y = 9;
+		off.x = 4;
+		off.y = 11;
 	} else {
 		off.x = 15;
-		off.y = 155;
+		off.y = 190;
 	}
 
@@ -806,5 +1091,5 @@
 	ui_image_set_rect(demo.image, &rect);
 
-	rc = ui_fixed_add(demo.fixed, ui_image_ctl(demo.image));
+	rc = ui_fixed_add(demo.bfixed, ui_image_ctl(demo.image));
 	if (rc != EOK) {
 		printf("Error adding control to layout.\n");
@@ -822,18 +1107,18 @@
 	/* FIXME: Auto layout */
 	if (ui_is_textmode(ui)) {
-		rect.p0.x = 2;
-		rect.p0.y = 12;
-		rect.p1.x = 12;
-		rect.p1.y = 13;
+		rect.p0.x = 4;
+		rect.p0.y = 14;
+		rect.p1.x = 14;
+		rect.p1.y = 15;
 	} else {
 		rect.p0.x = 15;
-		rect.p0.y = 190;
+		rect.p0.y = 225;
 		rect.p1.x = 140;
-		rect.p1.y = 210;
+		rect.p1.y = 245;
 	}
 
 	ui_checkbox_set_rect(demo.checkbox, &rect);
 
-	rc = ui_fixed_add(demo.fixed, ui_checkbox_ctl(demo.checkbox));
+	rc = ui_fixed_add(demo.bfixed, ui_checkbox_ctl(demo.checkbox));
 	if (rc != EOK) {
 		printf("Error adding control to layout.\n");
@@ -859,17 +1144,17 @@
 	/* FIXME: Auto layout */
 	if (ui_is_textmode(ui)) {
-		rect.p0.x = 2;
-		rect.p0.y = 14;
-		rect.p1.x = 12;
-		rect.p1.y = 15;
+		rect.p0.x = 4;
+		rect.p0.y = 16;
+		rect.p1.x = 14;
+		rect.p1.y = 17;
 	} else {
 		rect.p0.x = 15;
-		rect.p0.y = 220;
+		rect.p0.y = 255;
 		rect.p1.x = 140;
-		rect.p1.y = 240;
+		rect.p1.y = 275;
 	}
 	ui_rbutton_set_rect(demo.rbleft, &rect);
 
-	rc = ui_fixed_add(demo.fixed, ui_rbutton_ctl(demo.rbleft));
+	rc = ui_fixed_add(demo.bfixed, ui_rbutton_ctl(demo.rbleft));
 	if (rc != EOK) {
 		printf("Error adding control to layout.\n");
@@ -886,18 +1171,18 @@
 	/* FIXME: Auto layout */
 	if (ui_is_textmode(ui)) {
-		rect.p0.x = 2;
-		rect.p0.y = 15;
-		rect.p1.x = 12;
-		rect.p1.y = 16;
+		rect.p0.x = 4;
+		rect.p0.y = 17;
+		rect.p1.x = 14;
+		rect.p1.y = 18;
 	} else {
 		rect.p0.x = 15;
-		rect.p0.y = 250;
+		rect.p0.y = 285;
 		rect.p1.x = 140;
-		rect.p1.y = 270;
+		rect.p1.y = 305;
 	}
 	ui_rbutton_set_rect(demo.rbcenter, &rect);
 	ui_rbutton_select(demo.rbcenter);
 
-	rc = ui_fixed_add(demo.fixed, ui_rbutton_ctl(demo.rbcenter));
+	rc = ui_fixed_add(demo.bfixed, ui_rbutton_ctl(demo.rbcenter));
 	if (rc != EOK) {
 		printf("Error adding control to layout.\n");
@@ -914,17 +1199,17 @@
 	/* FIXME: Auto layout */
 	if (ui_is_textmode(ui)) {
-		rect.p0.x = 2;
-		rect.p0.y = 16;
-		rect.p1.x = 12;
-		rect.p1.y = 17;
+		rect.p0.x = 4;
+		rect.p0.y = 18;
+		rect.p1.x = 14;
+		rect.p1.y = 19;
 	} else {
 		rect.p0.x = 15;
-		rect.p0.y = 280;
+		rect.p0.y = 315;
 		rect.p1.x = 140;
-		rect.p1.y = 300;
+		rect.p1.y = 335;
 	}
 	ui_rbutton_set_rect(demo.rbright, &rect);
 
-	rc = ui_fixed_add(demo.fixed, ui_rbutton_ctl(demo.rbright));
+	rc = ui_fixed_add(demo.bfixed, ui_rbutton_ctl(demo.rbright));
 	if (rc != EOK) {
 		printf("Error adding control to layout.\n");
@@ -932,5 +1217,5 @@
 	}
 
-	rc = ui_slider_create(ui_res, "Slide!", &demo.slider);
+	rc = ui_slider_create(ui_res, &demo.slider);
 	if (rc != EOK) {
 		printf("Error creating button.\n");
@@ -942,22 +1227,167 @@
 	/* FIXME: Auto layout */
 	if (ui_is_textmode(ui)) {
-		rect.p0.x = 2;
-		rect.p0.y = 18;
-		rect.p1.x = 12;
-		rect.p1.y = 19;
+		rect.p0.x = 4;
+		rect.p0.y = 20;
+		rect.p1.x = 32;
+		rect.p1.y = 21;
 	} else {
 		rect.p0.x = 15;
-		rect.p0.y = 310;
+		rect.p0.y = 345;
 		rect.p1.x = 130;
-		rect.p1.y = 330;
+		rect.p1.y = 365;
 	}
 
 	ui_slider_set_rect(demo.slider, &rect);
 
-	rc = ui_fixed_add(demo.fixed, ui_slider_ctl(demo.slider));
+	rc = ui_fixed_add(demo.bfixed, ui_slider_ctl(demo.slider));
 	if (rc != EOK) {
 		printf("Error adding control to layout.\n");
 		return rc;
 	}
+
+	rc = ui_scrollbar_create(ui, window, ui_sbd_horiz, &demo.hscrollbar);
+	if (rc != EOK) {
+		printf("Error creating scrollbar.\n");
+		return rc;
+	}
+
+	ui_scrollbar_set_cb(demo.hscrollbar, &scrollbar_cb, (void *) &demo);
+
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 4;
+		rect.p0.y = 22;
+		rect.p1.x = 42;
+		rect.p1.y = 23;
+	} else {
+		rect.p0.x = 15;
+		rect.p0.y = 375;
+		rect.p1.x = 220;
+		rect.p1.y = 398;
+	}
+
+	ui_scrollbar_set_rect(demo.hscrollbar, &rect);
+
+	ui_scrollbar_set_thumb_length(demo.hscrollbar,
+	    ui_scrollbar_trough_length(demo.hscrollbar) / 4);
+
+	rc = ui_fixed_add(demo.bfixed, ui_scrollbar_ctl(demo.hscrollbar));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
+	rc = ui_scrollbar_create(ui, window, ui_sbd_vert, &demo.vscrollbar);
+	if (rc != EOK) {
+		printf("Error creating button.\n");
+		return rc;
+	}
+
+	ui_scrollbar_set_cb(demo.vscrollbar, &scrollbar_cb, (void *) &demo);
+
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 42;
+		rect.p0.y = 5;
+		rect.p1.x = 43;
+		rect.p1.y = 22;
+	} else {
+		rect.p0.x = 220;
+		rect.p0.y = 88;
+		rect.p1.x = 243;
+		rect.p1.y = 375;
+	}
+
+	ui_scrollbar_set_rect(demo.vscrollbar, &rect);
+
+	ui_scrollbar_set_thumb_length(demo.vscrollbar,
+	    ui_scrollbar_trough_length(demo.vscrollbar) / 4);
+
+	rc = ui_fixed_add(demo.bfixed, ui_scrollbar_ctl(demo.vscrollbar));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
+	ui_tab_add(demo.tbasic, ui_fixed_ctl(demo.bfixed));
+
+	rc = ui_fixed_create(&demo.lfixed);
+	if (rc != EOK) {
+		printf("Error creating fixed layout.\n");
+		return rc;
+	}
+
+	rc = ui_list_create(window, false, &demo.list);
+	if (rc != EOK) {
+		printf("Error creating list.\n");
+		return rc;
+	}
+
+	ui_list_entry_attr_init(&eattr);
+
+	eattr.caption = "One";
+	rc = ui_list_entry_append(demo.list, &eattr, NULL);
+	if (rc != EOK) {
+		printf("Error adding list entry.\n");
+		return rc;
+	}
+
+	eattr.caption = "Two";
+	rc = ui_list_entry_append(demo.list, &eattr, NULL);
+	if (rc != EOK) {
+		printf("Error adding list entry.\n");
+		return rc;
+	}
+
+	eattr.caption = "Three";
+	rc = ui_list_entry_append(demo.list, &eattr, NULL);
+	if (rc != EOK) {
+		printf("Error adding list entry.\n");
+		return rc;
+	}
+
+	eattr.caption = "Four";
+	rc = ui_list_entry_append(demo.list, &eattr, NULL);
+	if (rc != EOK) {
+		printf("Error adding list entry.\n");
+		return rc;
+	}
+
+	eattr.caption = "Five";
+	rc = ui_list_entry_append(demo.list, &eattr, NULL);
+	if (rc != EOK) {
+		printf("Error adding list entry.\n");
+		return rc;
+	}
+
+	eattr.caption = "Six";
+	rc = ui_list_entry_append(demo.list, &eattr, NULL);
+	if (rc != EOK) {
+		printf("Error adding list entry.\n");
+		return rc;
+	}
+
+	/* FIXME: Auto layout */
+	if (ui_is_textmode(ui)) {
+		rect.p0.x = 4;
+		rect.p0.y = 5;
+		rect.p1.x = 41;
+		rect.p1.y = 10;
+	} else {
+		rect.p0.x = 15;
+		rect.p0.y = 88;
+		rect.p1.x = 245;
+		rect.p1.y = 173;
+	}
+
+	ui_list_set_rect(demo.list, &rect);
+
+	rc = ui_fixed_add(demo.lfixed, ui_list_ctl(demo.list));
+	if (rc != EOK) {
+		printf("Error adding control to layout.\n");
+		return rc;
+	}
+
+	ui_tab_add(demo.tlists, ui_fixed_ctl(demo.lfixed));
 
 	ui_window_add(window, ui_fixed_ctl(demo.fixed));
@@ -1019,5 +1449,5 @@
 int main(int argc, char *argv[])
 {
-	const char *display_spec = UI_DISPLAY_DEFAULT;
+	const char *display_spec = UI_ANY_DEFAULT;
 	errno_t rc;
 	int i;
Index: uspace/app/uidemo/uidemo.h
===================================================================
--- uspace/app/uidemo/uidemo.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/app/uidemo/uidemo.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -42,9 +42,13 @@
 #include <ui/fixed.h>
 #include <ui/label.h>
+#include <ui/list.h>
 #include <ui/menu.h>
 #include <ui/menubar.h>
 #include <ui/pbutton.h>
 #include <ui/rbutton.h>
+#include <ui/scrollbar.h>
 #include <ui/slider.h>
+#include <ui/tab.h>
+#include <ui/tabset.h>
 #include <ui/ui.h>
 #include <ui/window.h>
@@ -55,4 +59,6 @@
 	ui_window_t *window;
 	ui_fixed_t *fixed;
+	ui_fixed_t *bfixed;
+	ui_fixed_t *lfixed;
 	ui_menu_bar_t *mbar;
 	ui_menu_t *mfile;
@@ -60,4 +66,7 @@
 	ui_menu_t *mpreferences;
 	ui_menu_t *mhelp;
+	ui_tab_set_t *tabset;
+	ui_tab_t *tbasic;
+	ui_tab_t *tlists;
 	ui_entry_t *entry;
 	ui_image_t *image;
@@ -71,4 +80,7 @@
 	ui_rbutton_t *rbright;
 	ui_slider_t *slider;
+	ui_scrollbar_t *hscrollbar;
+	ui_scrollbar_t *vscrollbar;
+	ui_list_t *list;
 } ui_demo_t;
 
